/*

  Copyright (C) 2001 StrmnNrmn

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#ifndef __CONFIGOPTIONS_H__
#define __CONFIGOPTIONS_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// Config stuff
struct DaedalusConfig
{
	bool		RecurseRomDirectory;
	bool		WarnMemoryErrors;
	bool		RunAutomatically;
	bool		TrapExceptions;		
	bool		ShowDebug;
#ifndef DAEDALUS_PSP
	RECT		rcMainWindow;			// Could probably be removed?
#endif
	TCHAR		szAiPluginFileName[MAX_PATH];
	TCHAR		szGfxPluginFileName[MAX_PATH];
	
	// Urgh - will make this a vector at some point!!
	enum { MAX_ROMS_DIRS = 100 };
	u32			nNumRomsDirs;
	TCHAR		szRomsDirs[MAX_ROMS_DIRS][MAX_PATH+1];


	TCHAR		szSaveDir[MAX_PATH+1];
};

extern DaedalusConfig	g_DaedalusConfig;

// Per-ROM config
extern BOOL g_bRDPEnableGfx;		// Show graphics
extern BOOL g_bUseDynarec;			// Use dynamic recompilation
extern BOOL g_bApplyPatches;		// Apply os-hooks
extern BOOL g_bSpeedSync;			// Sync vi speed

// Needs moving to Graphics plugin config
extern BOOL g_bDisplayNewCombiner;
extern BOOL g_bCRCCheck;			// Apply a crc-esque check to each texture each frame


#endif // __CONFIGOPTIONS_H__
