/*
Copyright (C) 2001 StrmnNrmn

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#ifndef __DAEDALUS_R4300_H__
#define __DAEDALUS_R4300_H__

#define CALL_TYPE		__fastcall
#define CALL_ARGS

typedef void (CALL_TYPE *CPU_Instruction )( CALL_ARGS );


#define ToInt(x)	*((int *)&x)
#define ToQuad(x)	*((u64 *)&x)
#define ToFloat(x)	*((float *)&x)
#define ToDouble(x)	*((double *)&x)

void R4300_SetSR( u32 new_value );

#ifdef _DEBUG
inline void CHECK_R0() {}
/*inline void CHECK_R0()
{
	if (gGPR[0]._u64 != 0)
	{
		DBGConsole_Msg(0, "Warning: Attempted write to r0!");
		gGPR[0]._u64 = 0;			// Ensure r0 is always zero (easier than trapping writes?)
	}
}*/

#else
inline void CHECK_R0() {}
#endif

extern CPU_Instruction R4300Instruction[64];
extern CPU_Instruction R4300SpecialInstruction[64];


void CALL_TYPE R4300_Unk( CALL_ARGS );
void CALL_TYPE R4300_Special( CALL_ARGS );
void CALL_TYPE R4300_RegImm( CALL_ARGS );
void CALL_TYPE R4300_J( CALL_ARGS );
void CALL_TYPE R4300_JAL( CALL_ARGS );
void CALL_TYPE R4300_BEQ( CALL_ARGS );
void CALL_TYPE R4300_BNE( CALL_ARGS );
void CALL_TYPE R4300_BLEZ( CALL_ARGS );
void CALL_TYPE R4300_BGTZ( CALL_ARGS );
void CALL_TYPE R4300_ADDI( CALL_ARGS );
void CALL_TYPE R4300_ADDIU( CALL_ARGS );
void CALL_TYPE R4300_SLTI( CALL_ARGS );
void CALL_TYPE R4300_SLTIU( CALL_ARGS );
void CALL_TYPE R4300_ANDI( CALL_ARGS );
void CALL_TYPE R4300_ORI( CALL_ARGS );
void CALL_TYPE R4300_XORI( CALL_ARGS );
void CALL_TYPE R4300_LUI( CALL_ARGS );
void CALL_TYPE R4300_CoPro0( CALL_ARGS );
void CALL_TYPE R4300_CoPro1( CALL_ARGS );
void CALL_TYPE R4300_CoPro1_Disabled( CALL_ARGS );
void CALL_TYPE R4300_SRHack_UnOpt( CALL_ARGS );
void CALL_TYPE R4300_SRHack_Opt( CALL_ARGS );
void CALL_TYPE R4300_SRHack_NoOpt( CALL_ARGS );
void CALL_TYPE R4300_BEQL( CALL_ARGS );
void CALL_TYPE R4300_BNEL( CALL_ARGS );
void CALL_TYPE R4300_BLEZL( CALL_ARGS );
void CALL_TYPE R4300_BGTZL( CALL_ARGS );
void CALL_TYPE R4300_DADDI( CALL_ARGS );
void CALL_TYPE R4300_DADDIU( CALL_ARGS );
void CALL_TYPE R4300_LDL( CALL_ARGS );
void CALL_TYPE R4300_LDR( CALL_ARGS );
void CALL_TYPE R4300_Patch( CALL_ARGS );
void CALL_TYPE R4300_LB( CALL_ARGS );
void CALL_TYPE R4300_LH( CALL_ARGS );
void CALL_TYPE R4300_LWL( CALL_ARGS );
void CALL_TYPE R4300_LW( CALL_ARGS );
void CALL_TYPE R4300_LBU( CALL_ARGS );
void CALL_TYPE R4300_LHU( CALL_ARGS );
void CALL_TYPE R4300_LWR( CALL_ARGS );
void CALL_TYPE R4300_LWU( CALL_ARGS );
void CALL_TYPE R4300_SB( CALL_ARGS );
void CALL_TYPE R4300_SH( CALL_ARGS );
void CALL_TYPE R4300_SWL( CALL_ARGS );
void CALL_TYPE R4300_SW( CALL_ARGS );
void CALL_TYPE R4300_SDL( CALL_ARGS );
void CALL_TYPE R4300_SDR( CALL_ARGS );
void CALL_TYPE R4300_SWR( CALL_ARGS );
void CALL_TYPE R4300_CACHE( CALL_ARGS );
void CALL_TYPE R4300_LL( CALL_ARGS );
void CALL_TYPE R4300_LWC1( CALL_ARGS );
void CALL_TYPE R4300_LLD( CALL_ARGS );
void CALL_TYPE R4300_LDC1( CALL_ARGS );
void CALL_TYPE R4300_LDC2( CALL_ARGS );
void CALL_TYPE R4300_LD( CALL_ARGS );
void CALL_TYPE R4300_SC( CALL_ARGS );
void CALL_TYPE R4300_SWC1( CALL_ARGS );
void CALL_TYPE R4300_DBG_Bkpt( CALL_ARGS );
void CALL_TYPE R4300_SCD( CALL_ARGS );
void CALL_TYPE R4300_SDC1( CALL_ARGS );
void CALL_TYPE R4300_SDC2( CALL_ARGS );
void CALL_TYPE R4300_SD( CALL_ARGS );


void CALL_TYPE R4300_Special_Unk( CALL_ARGS );
void CALL_TYPE R4300_Special_SLL( CALL_ARGS );
void CALL_TYPE R4300_Special_SRL( CALL_ARGS );
void CALL_TYPE R4300_Special_SRA( CALL_ARGS );
void CALL_TYPE R4300_Special_SLLV( CALL_ARGS );
void CALL_TYPE R4300_Special_SRLV( CALL_ARGS );
void CALL_TYPE R4300_Special_SRAV( CALL_ARGS );
void CALL_TYPE R4300_Special_JR_CheckBootAddress( CALL_ARGS );		// Special version to check for jump to game boot address
void CALL_TYPE R4300_Special_JR( CALL_ARGS );
void CALL_TYPE R4300_Special_JALR( CALL_ARGS );
void CALL_TYPE R4300_Special_SYSCALL( CALL_ARGS );
void CALL_TYPE R4300_Special_BREAK( CALL_ARGS );
void CALL_TYPE R4300_Special_SYNC( CALL_ARGS );
void CALL_TYPE R4300_Special_MFHI( CALL_ARGS );
void CALL_TYPE R4300_Special_MTHI( CALL_ARGS );
void CALL_TYPE R4300_Special_MFLO( CALL_ARGS );
void CALL_TYPE R4300_Special_MTLO( CALL_ARGS );
void CALL_TYPE R4300_Special_DSLLV( CALL_ARGS );
void CALL_TYPE R4300_Special_DSRLV( CALL_ARGS );
void CALL_TYPE R4300_Special_DSRAV( CALL_ARGS );
void CALL_TYPE R4300_Special_MULT( CALL_ARGS );
void CALL_TYPE R4300_Special_MULTU( CALL_ARGS );
void CALL_TYPE R4300_Special_DIV( CALL_ARGS );
void CALL_TYPE R4300_Special_DIVU( CALL_ARGS );
void CALL_TYPE R4300_Special_DMULT( CALL_ARGS );
void CALL_TYPE R4300_Special_DMULTU( CALL_ARGS );
void CALL_TYPE R4300_Special_DDIV( CALL_ARGS );
void CALL_TYPE R4300_Special_DDIVU( CALL_ARGS );
void CALL_TYPE R4300_Special_ADD( CALL_ARGS );
void CALL_TYPE R4300_Special_ADDU( CALL_ARGS );
void CALL_TYPE R4300_Special_SUB( CALL_ARGS );
void CALL_TYPE R4300_Special_SUBU( CALL_ARGS );
void CALL_TYPE R4300_Special_AND( CALL_ARGS );
void CALL_TYPE R4300_Special_OR( CALL_ARGS );
void CALL_TYPE R4300_Special_XOR( CALL_ARGS );
void CALL_TYPE R4300_Special_NOR( CALL_ARGS );
void CALL_TYPE R4300_Special_SLT( CALL_ARGS );
void CALL_TYPE R4300_Special_SLTU( CALL_ARGS );
void CALL_TYPE R4300_Special_DADD( CALL_ARGS );
void CALL_TYPE R4300_Special_DADDU( CALL_ARGS );
void CALL_TYPE R4300_Special_DSUB( CALL_ARGS );
void CALL_TYPE R4300_Special_DSUBU( CALL_ARGS );
void CALL_TYPE R4300_Special_TGE( CALL_ARGS );
void CALL_TYPE R4300_Special_TGEU( CALL_ARGS );
void CALL_TYPE R4300_Special_TLT( CALL_ARGS );
void CALL_TYPE R4300_Special_TLTU( CALL_ARGS );
void CALL_TYPE R4300_Special_TEQ( CALL_ARGS );
void CALL_TYPE R4300_Special_TNE( CALL_ARGS );
void CALL_TYPE R4300_Special_DSLL( CALL_ARGS );
void CALL_TYPE R4300_Special_DSRL( CALL_ARGS );
void CALL_TYPE R4300_Special_DSRA( CALL_ARGS );
void CALL_TYPE R4300_Special_DSLL32( CALL_ARGS );
void CALL_TYPE R4300_Special_DSRL32( CALL_ARGS );
void CALL_TYPE R4300_Special_DSRA32( CALL_ARGS );


void CALL_TYPE R4300_RegImm_Unk( CALL_ARGS );
void CALL_TYPE R4300_RegImm_BLTZ( CALL_ARGS );
void CALL_TYPE R4300_RegImm_BGEZ( CALL_ARGS );
void CALL_TYPE R4300_RegImm_BLTZL( CALL_ARGS );
void CALL_TYPE R4300_RegImm_BGEZL( CALL_ARGS );
void CALL_TYPE R4300_RegImm_TGEI( CALL_ARGS );
void CALL_TYPE R4300_RegImm_TGEIU( CALL_ARGS );
void CALL_TYPE R4300_RegImm_TLTI( CALL_ARGS );
void CALL_TYPE R4300_RegImm_TLTIU( CALL_ARGS );
void CALL_TYPE R4300_RegImm_TEQI( CALL_ARGS );
void CALL_TYPE R4300_RegImm_TNEI( CALL_ARGS );
void CALL_TYPE R4300_RegImm_BLTZAL( CALL_ARGS );
void CALL_TYPE R4300_RegImm_BGEZAL( CALL_ARGS );
void CALL_TYPE R4300_RegImm_BLTZALL( CALL_ARGS );
void CALL_TYPE R4300_RegImm_BGEZALL( CALL_ARGS );


void CALL_TYPE R4300_Cop0_Unk( CALL_ARGS );
void CALL_TYPE R4300_Cop0_MFC0( CALL_ARGS );
void CALL_TYPE R4300_Cop0_MTC0( CALL_ARGS );
void CALL_TYPE R4300_Cop0_TLB( CALL_ARGS );


void CALL_TYPE R4300_TLB_Unk( CALL_ARGS );
void CALL_TYPE R4300_TLB_TLBR( CALL_ARGS );
void CALL_TYPE R4300_TLB_TLBWI( CALL_ARGS );
void CALL_TYPE R4300_TLB_TLBWR( CALL_ARGS );
void CALL_TYPE R4300_TLB_TLBP( CALL_ARGS );
void CALL_TYPE R4300_TLB_ERET( CALL_ARGS );



void CALL_TYPE R4300_Cop1_Unk( CALL_ARGS );
void CALL_TYPE R4300_Cop1_MFC1( CALL_ARGS );
void CALL_TYPE R4300_Cop1_DMFC1( CALL_ARGS );
void CALL_TYPE R4300_Cop1_CFC1( CALL_ARGS );
void CALL_TYPE R4300_Cop1_MTC1( CALL_ARGS );
void CALL_TYPE R4300_Cop1_DMTC1( CALL_ARGS );
void CALL_TYPE R4300_Cop1_CTC1( CALL_ARGS );
void CALL_TYPE R4300_Cop1_BCInstr( CALL_ARGS );
void CALL_TYPE R4300_Cop1_SInstr( CALL_ARGS );
void CALL_TYPE R4300_Cop1_DInstr( CALL_ARGS );
void CALL_TYPE R4300_Cop1_WInstr( CALL_ARGS );
void CALL_TYPE R4300_Cop1_LInstr( CALL_ARGS );

void CALL_TYPE R4300_BC1_BC1F( CALL_ARGS );
void CALL_TYPE R4300_BC1_BC1T( CALL_ARGS );
void CALL_TYPE R4300_BC1_BC1FL( CALL_ARGS );
void CALL_TYPE R4300_BC1_BC1TL( CALL_ARGS );


void CALL_TYPE R4300_Cop1_S_Unk( CALL_ARGS );
void CALL_TYPE R4300_Cop1_S_ADD( CALL_ARGS );
void CALL_TYPE R4300_Cop1_S_SUB( CALL_ARGS );
void CALL_TYPE R4300_Cop1_S_MUL( CALL_ARGS );
void CALL_TYPE R4300_Cop1_S_DIV( CALL_ARGS );
void CALL_TYPE R4300_Cop1_S_SQRT( CALL_ARGS );
void CALL_TYPE R4300_Cop1_S_ABS( CALL_ARGS );
void CALL_TYPE R4300_Cop1_S_MOV( CALL_ARGS );
void CALL_TYPE R4300_Cop1_S_NEG( CALL_ARGS );
void CALL_TYPE R4300_Cop1_S_ROUND_L( CALL_ARGS );
void CALL_TYPE R4300_Cop1_S_TRUNC_L( CALL_ARGS );
void CALL_TYPE R4300_Cop1_S_CEIL_L( CALL_ARGS );
void CALL_TYPE R4300_Cop1_S_FLOOR_L( CALL_ARGS );
void CALL_TYPE R4300_Cop1_S_ROUND_W( CALL_ARGS );
void CALL_TYPE R4300_Cop1_S_TRUNC_W( CALL_ARGS );
void CALL_TYPE R4300_Cop1_S_CEIL_W( CALL_ARGS );
void CALL_TYPE R4300_Cop1_S_FLOOR_W( CALL_ARGS );
void CALL_TYPE R4300_Cop1_S_CVT_D( CALL_ARGS );
void CALL_TYPE R4300_Cop1_S_CVT_W( CALL_ARGS );
void CALL_TYPE R4300_Cop1_S_CVT_L( CALL_ARGS );
void CALL_TYPE R4300_Cop1_S_F( CALL_ARGS );
void CALL_TYPE R4300_Cop1_S_UN( CALL_ARGS );
void CALL_TYPE R4300_Cop1_S_EQ( CALL_ARGS );
void CALL_TYPE R4300_Cop1_S_UEQ( CALL_ARGS );
void CALL_TYPE R4300_Cop1_S_OLT( CALL_ARGS );
void CALL_TYPE R4300_Cop1_S_ULT( CALL_ARGS );
void CALL_TYPE R4300_Cop1_S_OLE( CALL_ARGS );
void CALL_TYPE R4300_Cop1_S_ULE( CALL_ARGS );
void CALL_TYPE R4300_Cop1_S_SF( CALL_ARGS );
void CALL_TYPE R4300_Cop1_S_NGLE( CALL_ARGS );
void CALL_TYPE R4300_Cop1_S_SEQ( CALL_ARGS );
void CALL_TYPE R4300_Cop1_S_NGL( CALL_ARGS );
void CALL_TYPE R4300_Cop1_S_LT( CALL_ARGS );
void CALL_TYPE R4300_Cop1_S_NGE( CALL_ARGS );
void CALL_TYPE R4300_Cop1_S_LE( CALL_ARGS );
void CALL_TYPE R4300_Cop1_S_NGT( CALL_ARGS );


void CALL_TYPE R4300_Cop1_W_CVT_S( CALL_ARGS );
void CALL_TYPE R4300_Cop1_W_CVT_D( CALL_ARGS );

void CALL_TYPE R4300_Cop1_L_CVT_S( CALL_ARGS );
void CALL_TYPE R4300_Cop1_L_CVT_D( CALL_ARGS );

void CALL_TYPE R4300_Cop1_D_Unk( CALL_ARGS );
void CALL_TYPE R4300_Cop1_D_ADD( CALL_ARGS );
void CALL_TYPE R4300_Cop1_D_SUB( CALL_ARGS );
void CALL_TYPE R4300_Cop1_D_MUL( CALL_ARGS );
void CALL_TYPE R4300_Cop1_D_DIV( CALL_ARGS );
void CALL_TYPE R4300_Cop1_D_SQRT( CALL_ARGS );
void CALL_TYPE R4300_Cop1_D_ABS( CALL_ARGS );
void CALL_TYPE R4300_Cop1_D_MOV( CALL_ARGS );
void CALL_TYPE R4300_Cop1_D_NEG( CALL_ARGS );
void CALL_TYPE R4300_Cop1_D_ROUND_L( CALL_ARGS );
void CALL_TYPE R4300_Cop1_D_TRUNC_L( CALL_ARGS );
void CALL_TYPE R4300_Cop1_D_CEIL_L( CALL_ARGS );
void CALL_TYPE R4300_Cop1_D_FLOOR_L( CALL_ARGS );
void CALL_TYPE R4300_Cop1_D_ROUND_W( CALL_ARGS );
void CALL_TYPE R4300_Cop1_D_TRUNC_W( CALL_ARGS );
void CALL_TYPE R4300_Cop1_D_CEIL_W( CALL_ARGS );
void CALL_TYPE R4300_Cop1_D_FLOOR_W( CALL_ARGS );
void CALL_TYPE R4300_Cop1_D_CVT_S( CALL_ARGS );
void CALL_TYPE R4300_Cop1_D_CVT_W( CALL_ARGS );
void CALL_TYPE R4300_Cop1_D_CVT_L( CALL_ARGS );
void CALL_TYPE R4300_Cop1_D_F( CALL_ARGS );
void CALL_TYPE R4300_Cop1_D_UN( CALL_ARGS );
void CALL_TYPE R4300_Cop1_D_EQ( CALL_ARGS );
void CALL_TYPE R4300_Cop1_D_UEQ( CALL_ARGS );
void CALL_TYPE R4300_Cop1_D_OLT( CALL_ARGS );
void CALL_TYPE R4300_Cop1_D_ULT( CALL_ARGS );
void CALL_TYPE R4300_Cop1_D_OLE( CALL_ARGS );
void CALL_TYPE R4300_Cop1_D_ULE( CALL_ARGS );
void CALL_TYPE R4300_Cop1_D_SF( CALL_ARGS );
void CALL_TYPE R4300_Cop1_D_NGLE( CALL_ARGS );
void CALL_TYPE R4300_Cop1_D_SEQ( CALL_ARGS );
void CALL_TYPE R4300_Cop1_D_NGL( CALL_ARGS );
void CALL_TYPE R4300_Cop1_D_LT( CALL_ARGS );
void CALL_TYPE R4300_Cop1_D_NGE( CALL_ARGS );
void CALL_TYPE R4300_Cop1_D_LE( CALL_ARGS );
void CALL_TYPE R4300_Cop1_D_NGT( CALL_ARGS );



#endif
