/*
Copyright (C) 2005 StrmnNrmn

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#if _MSC_VER > 1000
#pragma once
#endif

#ifndef ASSEMBLYWRITERPSP_H_
#define ASSEMBLYWRITERPSP_H_

#include "AssemblyBuffer.h"
#include "DynarecTargetPSP.h"

#include "Core\Registers.h"

class CAssemblyWriterPSP
{
	public:
		CAssemblyWriterPSP( CAssemblyBuffer * p_buffer )
			:	mpAssemblyBuffer( p_buffer )
		{
		}

	public:
		CAssemblyBuffer *	GetAssemblyBuffer() const									{ return mpAssemblyBuffer; }
		void				SetAssemblyBuffer( CAssemblyBuffer * p_buffer )				{ mpAssemblyBuffer = p_buffer; }

	// XXXX
	private:
	public:
		void				LoadConstant( EMipsReg reg, s32 value );

		void				LoadRegister( EMipsReg reg_dst, OpCodeValue load_op, EMipsReg reg_base, s16 offset );
		void				StoreRegister( EMipsReg reg_src, OpCodeValue store_op, EMipsReg reg_base, s16 offset );

		void				LUI( EMipsReg reg, u16 value );

		void				SW( EMipsReg reg_src, EMipsReg reg_base, s16 offset );

		void				JAL( const void * p_target );

	private:

		inline void AppendOp( OpCode op )
		{
			mpAssemblyBuffer->EmitDWORD( op._u32 );
		}

	private:
		CAssemblyBuffer *				mpAssemblyBuffer;
};

#endif // ASSEMBLYWRITERPSP_H_
