#define SR_COP1_OPTIMISE_FLAG		(pCode->dwOptimiseLevel < 1)
//#define SR_COP1_OPTIMISE_FLAG		1

#define TEST_DISABLE_SR_COP1		//return FALSE;

//*****************************************************************************
//
//*****************************************************************************
BOOL SR_Emit_Cop1_MFC1(CDynarecCode *pCode, OpCode op_code, DWORD * pdwFlags)
{
TEST_DISABLE_SR_COP1
	const u32 dwRT = op_code.rt;
	const u32 dwFS = op_code.fs;

	pCode->Stat_D(dwRT);
	pCode->Stat_Single_S(dwFS);
	
	if (SR_COP1_OPTIMISE_FLAG)
	{
		SR_Emit_Generic_R4300(pCode, op_code, R4300_Cop1_MFC1);
	}
	else
	{
		pCode->dwNumOptimised++;

		pCode->mpCodeGenerator->GenerateMFC1( dwRT, dwFS );
	}
	return TRUE;
}

//*****************************************************************************
//
//*****************************************************************************
BOOL SR_Emit_Cop1_MTC1(CDynarecCode *pCode, OpCode op_code, DWORD * pdwFlags)
{
TEST_DISABLE_SR_COP1
	const u32 dwRT = op_code.rt;
	const u32 dwFS = op_code.fs;

	pCode->Stat_S(dwRT);
	pCode->Stat_Single_D(dwFS);

	if (SR_COP1_OPTIMISE_FLAG)
	{
		SR_Emit_Generic_R4300(pCode, op_code, R4300_Cop1_MTC1);
	}
	else
	{
		pCode->dwNumOptimised++;

		pCode->mpCodeGenerator->GenerateMTC1( dwFS, dwRT );
	}
	return TRUE;
}

//*****************************************************************************
//
//*****************************************************************************
BOOL SR_Emit_Cop1_CFC1(CDynarecCode *pCode, OpCode op_code, DWORD * pdwFlags)
{
TEST_DISABLE_SR_COP1
	const u32 dwFS = op_code.fs;
	const u32 dwRT = op_code.rt;

	pCode->Stat_D(dwRT);

	// Uses CCR reg
	if (SR_COP1_OPTIMISE_FLAG)
	{
		SR_Emit_Generic_R4300(pCode, op_code, R4300_Cop1_CFC1);
	}
	else
	{
		pCode->dwNumOptimised++;

		pCode->mpCodeGenerator->GenerateCFC1( dwRT, dwFS );
	}

	return TRUE;
}

//*****************************************************************************
//
//*****************************************************************************
BOOL SR_Emit_Cop1_CTC1(CDynarecCode *pCode, OpCode op_code, DWORD * pdwFlags)
{
TEST_DISABLE_SR_COP1
	const u32 dwFS = op_code.fs;
	const u32 dwRT = op_code.rt;

	pCode->Stat_S(dwRT);
	// USes CCR

	if (SR_COP1_OPTIMISE_FLAG)
	{
		SR_Emit_Generic_R4300(pCode, op_code, R4300_Cop1_CTC1);
	}
	else
	{
		pCode->dwNumOptimised++;

		pCode->mpCodeGenerator->GenerateCTC1( dwFS, dwRT );
	}

	return TRUE;
}

