#define SR_LOAD_OPTIMISE_FLAG		pCode->dwOptimiseLevel < 1
//#define SR_LOAD_OPTIMISE_FLAG		1

#define TEST_DISABLE_SR_LOAD		//return FALSE;

//*****************************************************************************
//
//*****************************************************************************
BOOL SR_Emit_LB(CDynarecCode *pCode, OpCode op_code, DWORD * pdwFlags)
{
TEST_DISABLE_SR_LOAD
	const u32 dwRT = op_code.rt;
	const u32 dwBase = op_code.rs;

	pCode->Stat_Load_B_D(dwBase, dwRT);

	if (SR_LOAD_OPTIMISE_FLAG)
	{
		SR_Emit_Generic_R4300(pCode, op_code, R4300_LB);
	}
	else
	{
		s32  nOffset = (s32)(s16)op_code.immediate;

		pCode->dwNumOptimised++;

		pCode->mpCodeGenerator->GenerateLB( dwRT, dwBase, nOffset );
	}
		
	return TRUE;
}

//*****************************************************************************
//
//*****************************************************************************
BOOL SR_Emit_LBU(CDynarecCode *pCode, OpCode op_code, DWORD * pdwFlags)
{
TEST_DISABLE_SR_LOAD
	const u32 dwRT = op_code.rt;
	const u32 dwBase = op_code.rs;

	pCode->Stat_Load_B_D(dwBase, dwRT);

	if (SR_LOAD_OPTIMISE_FLAG)
	{
		SR_Emit_Generic_R4300(pCode, op_code, R4300_LBU);
	}
	else
	{
		s32  nOffset = (s32)(s16)op_code.immediate;

		pCode->dwNumOptimised++;

		pCode->mpCodeGenerator->GenerateLBU( dwRT, dwBase, nOffset );
	}
		
	return TRUE;
}

//*****************************************************************************
//
//*****************************************************************************
BOOL SR_Emit_LH(CDynarecCode *pCode, OpCode op_code, DWORD * pdwFlags)
{
TEST_DISABLE_SR_LOAD
	const u32 dwRT = op_code.rt;
	const u32 dwBase = op_code.rs;

	pCode->Stat_Load_B_D(dwBase, dwRT);
	
	if (SR_LOAD_OPTIMISE_FLAG)
	{
		SR_Emit_Generic_R4300(pCode, op_code, R4300_LH);
	}
	else
	{
		s32  nOffset = (s32)(s16)op_code.immediate;

		pCode->dwNumOptimised++;

		pCode->mpCodeGenerator->GenerateLH( dwRT, dwBase, nOffset );
	}

	return TRUE;
}

//*****************************************************************************
//
//*****************************************************************************
BOOL SR_Emit_LHU(CDynarecCode *pCode, OpCode op_code, DWORD * pdwFlags)
{
TEST_DISABLE_SR_LOAD
	const u32 dwRT = op_code.rt;
	const u32 dwBase = op_code.rs;

	pCode->Stat_Load_B_D(dwBase, dwRT);
	
	if (SR_LOAD_OPTIMISE_FLAG)
	{
		SR_Emit_Generic_R4300(pCode, op_code, R4300_LHU);
	}
	else
	{
		s32  nOffset = (s32)(s16)op_code.immediate;

		pCode->dwNumOptimised++;

		pCode->mpCodeGenerator->GenerateLHU( dwRT, dwBase, nOffset );
	}

	return TRUE;
}

//*****************************************************************************
//
//*****************************************************************************
BOOL SR_Emit_LW(CDynarecCode *pCode, OpCode op_code, DWORD * pdwFlags)
{
TEST_DISABLE_SR_LOAD
	const u32 dwRT = op_code.rt;
	const u32 dwBase = op_code.rs;

	//DWORD	dwAddress = (u32)((s32)gGPR[dwBase] + nOffset);
	//gGPR[dwRT] = (s64)(s32)Read32Bits(dwAddress);

	pCode->Stat_Load_B_D(dwBase, dwRT);

	if (SR_LOAD_OPTIMISE_FLAG)
	{
		SR_Emit_Generic_R4300(pCode, op_code, R4300_LW);
	}
	else
	{
		s32  nOffset = (s32)(s16)op_code.immediate;

		pCode->dwNumOptimised++;

		pCode->mpCodeGenerator->GenerateLW( dwRT, dwBase, nOffset );
	}

	return TRUE;
}

//*****************************************************************************
//
//*****************************************************************************
BOOL SR_Emit_LWC1(CDynarecCode *pCode, OpCode op_code, DWORD * pdwFlags)
{
TEST_DISABLE_SR_LOAD
	const u32 dwBase = op_code.rs;
	const u32 dwFT = op_code.ft;

	/*
	DWORD dwAddress = (u32)((s32)gGPR[dwBase] + (s32)wOffset);
	StoreFPR_Word(dwFT, Read32Bits(dwAddress));
	*/

	pCode->Stat_Load_B(dwBase);
	pCode->Stat_Single_D(dwFT);

	if (SR_LOAD_OPTIMISE_FLAG)
	{
		SR_Emit_Generic_R4300(pCode, op_code, R4300_LWC1);
	}
	else
	{
		pCode->dwNumOptimised++;

		s32  nOffset = (s32)(s16)op_code.immediate;

		pCode->mpCodeGenerator->GenerateLWC1( dwFT, dwBase, nOffset );
	}
	return TRUE;
}

//*****************************************************************************
//
//*****************************************************************************

/*
00452D58 8B 40 0A             mov         eax,dword ptr [eax+0Ah]
00452D5B 8B 50 0A             mov         edx,dword ptr [eax+0Ah]
00452D5E 8B 80 EF BE AD DE    mov         eax,dword ptr [eax-21524111h]
00452D64 8B 90 EF BE AD DE    mov         edx,dword ptr [eax-21524111h]


00452D28 8B 46 0A             mov         eax,dword ptr [esi+0Ah]
00452D2B 8B 56 0A             mov         edx,dword ptr [esi+0Ah]

00453258 8B 86 EF BE AD DE    mov         eax,dword ptr [esi-21524111h]
0045325E 8B 96 EF BE AD DE    mov         edx,dword ptr [esi-21524111h]
00453264 8B 00                mov         eax,dword ptr [eax]
00453266 8B 50 04             mov         edx,dword ptr [eax+4]
*/

BOOL SR_Emit_LDC1(CDynarecCode *pCode, OpCode op_code, DWORD * pdwFlags)
{
TEST_DISABLE_SR_LOAD
return FALSE;
	const u32 dwBase = op_code.rs;
	const u32 dwFT = op_code.ft;

	pCode->Stat_Load_B(dwBase);
	pCode->Stat_Double_D(dwFT);

	//if (SR_LOAD_OPTIMISE_FLAG)
	{
		SR_Emit_Generic_R4300(pCode, op_code, R4300_LDC1);
	}

	return TRUE;
}







