#define SR_STORE_OPTIMISE_FLAG		pCode->dwOptimiseLevel < 1
//#define SR_STORE_OPTIMISE_FLAG		1

#define TEST_DISABLE_SR_STORE		//return FALSE;

//*****************************************************************************
//
//*****************************************************************************
BOOL SR_Emit_SW(CDynarecCode *pCode, OpCode op_code, DWORD * pdwFlags)
{
TEST_DISABLE_SR_STORE
	const u32 dwRT = op_code.rt;
	const u32 dwBase = op_code.rs;

	pCode->Stat_Save_B_S(dwBase, dwRT);
		
	if (SR_STORE_OPTIMISE_FLAG)
	{
		SR_Emit_Generic_R4300(pCode, op_code, R4300_SW);
	}
	else
	{
		s32  nOffset = (s32)(s16)op_code.immediate;

		pCode->dwNumOptimised++;

		pCode->mpCodeGenerator->GenerateSW( dwRT, dwBase, nOffset );
	}
	
	return TRUE;
}

//*****************************************************************************
//
//*****************************************************************************
BOOL SR_Emit_SH(CDynarecCode *pCode, OpCode op_code, DWORD * pdwFlags)
{
TEST_DISABLE_SR_STORE
	const u32 dwRT = op_code.rt;
	const u32 dwBase = op_code.rs;

	pCode->Stat_Save_B_S(dwBase, dwRT);
	
	if (SR_STORE_OPTIMISE_FLAG)
	{
		SR_Emit_Generic_R4300(pCode, op_code, R4300_SH);
	}
	else
	{
		s32  nOffset = (s32)(s16)op_code.immediate;

		pCode->dwNumOptimised++;

		pCode->mpCodeGenerator->GenerateSH( dwRT, dwBase, nOffset );
	}
	
	return TRUE;
}

//*****************************************************************************
//
//*****************************************************************************
BOOL SR_Emit_SB(CDynarecCode *pCode, OpCode op_code, DWORD * pdwFlags)
{
TEST_DISABLE_SR_STORE
	const u32 dwRT = op_code.rt;
	const u32 dwBase = op_code.rs;

	pCode->Stat_Save_B_S(dwBase, dwRT);

	if (SR_STORE_OPTIMISE_FLAG)
	{
		SR_Emit_Generic_R4300(pCode, op_code, R4300_SB);
	}
	else
	{
		s32  nOffset = (s32)(s16)op_code.immediate;

		pCode->dwNumOptimised++;

		pCode->mpCodeGenerator->GenerateSB( dwRT, dwBase, nOffset );
	}

	return TRUE;
}

//*****************************************************************************
//
//*****************************************************************************
BOOL SR_Emit_SWC1(CDynarecCode *pCode, OpCode op_code, DWORD * pdwFlags)
{
TEST_DISABLE_SR_STORE
	const u32 dwBase = op_code.rs;
	const u32 dwFT = op_code.ft;

	pCode->Stat_Save_B(dwBase);
	pCode->Stat_Single_S(dwFT);
	
	if (SR_STORE_OPTIMISE_FLAG)
	{
		SR_Emit_Generic_R4300(pCode, op_code, R4300_SWC1);
	}
	else
	{
		pCode->dwNumOptimised++;

		s32  nOffset = (s32)(s16)op_code.immediate;

		pCode->mpCodeGenerator->GenerateSWC1( dwFT, dwBase, nOffset );
	}

	return TRUE;
}

//*****************************************************************************
//
//*****************************************************************************
BOOL SR_Emit_SDC1(CDynarecCode *pCode, OpCode op_code, DWORD * pdwFlags)
{
TEST_DISABLE_SR_STORE
	const u32 dwBase = op_code.rs;
	const u32 dwFT = op_code.ft;

	pCode->Stat_Save_B(dwBase);
	pCode->Stat_Double_S(dwFT);
	
	//if (SR_STORE_OPTIMISE_FLAG)
	{
		SR_Emit_Generic_R4300(pCode, op_code, R4300_SDC1);
	}

	return TRUE;
}
