#ifndef __INPUTMANAGER_H__
#define __INPUTMANAGER_H__

#include "OSHLE/ultra_os.h"
#include "DaedSingleton.h"

#ifdef DAEDALUS_XB

enum EXboxButton
{
	XBB_A = 0,
	XBB_DPAD_UP,
	XBB_DPAD_DOWN,
};

void	Input_Process();
void	Input_GetLeftStickState( float * p_x, float * p_y );
bool	Input_IsNewlyPressed( EXboxButton button );

#endif

class CInputManager : public CSingleton< CInputManager >
{
	public:
		virtual ~CInputManager() {}

#ifdef DAEDALUS_W32
		virtual bool Initialise( HWND hWnd ) = 0;
		virtual void Unaquire() = 0;
		virtual void Configure(HWND hWndParent) = 0;

		// Nasty - should really be hidden in implementation
		virtual BOOL InputSelectDialogProc(HWND hWndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam) = 0;
		virtual BOOL InputConfigDialogProc(HWND hWndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam) = 0;
#else
		virtual bool Initialise() = 0;
#endif

		virtual void Finalise() = 0;

		virtual bool GetState( OSContPad pPad[4] ) = 0;
};

#endif // __INPUTMANAGER_H__
