/*
Copyright (C) 2004 StrmnNrmn

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

//*****************************************************************************
// Include files
//*****************************************************************************
#include "stdafx.h"
#include "MainWindow.h"

//*****************************************************************************
//
//*****************************************************************************
class IMainWindow : public CMainWindow
{
	public:
		IMainWindow();
		~IMainWindow() {}

		HRESULT CreateWnd(INT nWinMode)												{ return S_OK; }

		void SelectSaveDir(HWND hWndParent)											{}

		void __cdecl SetStatus(INT nPiece, LPCTSTR szFormat, ...)					{}

		LRESULT WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)		{ return 0; }

		u32		MessageBox( const CHAR * msg, const CHAR * title = "Daedalus", u32 flags = MB_OK )
		{
			DAEDALUS_ASSERTMSG( msg );
			return MB_OK;
		}
};


//*****************************************************************************
// Singleton creation
//*****************************************************************************
bool CSingleton< CMainWindow >::Create()
{
	_ASSERT(mpInstance == NULL);
	mpInstance = new IMainWindow();
	return true;
}

//*****************************************************************************
//
//*****************************************************************************
IMainWindow::IMainWindow()
{
	m_hWnd = NULL;
	m_hWndStatus = NULL;
}
