/*
Copyright (C) 2001,2006 StrmnNrmn

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#ifndef __DAEDALUS_DEBUGDISPLAYLIST_H__
#define __DAEDALUS_DEBUGDISPLAYLIST_H__


#include <stdarg.h>
//*************************************************************************************
// 
//*************************************************************************************
void Debug_DumpLine (FILE * hFile, LPCTSTR szFormat, va_list va);
extern u32 gTesselatorVerticesIn;
extern u32 gTesselatorVerticesOut;

extern FILE * g_hRDPDumpHandle;


// Lkb - I changed this to DAEDALUS_RELEASE_BUILD (from _DEBUG) because
// I tend to dump display lists a lot when developing. This #define 
// can be used for other features that don't need to be included in
// a public release 
#ifndef DAEDALUS_RELEASE_BUILD
inline void __cdecl DL_PF(LPCTSTR szFormat, ...)
{
	if (g_hRDPDumpHandle == NULL)
		return;

    va_list va;

	va_start(va, szFormat);
	Debug_DumpLine(g_hRDPDumpHandle, szFormat, va);
	va_end(va);
	
}
#else
// BEGIN MODIFIED BY Lkb - 9/jun/2001 - GCC support
#ifdef __GNUC__
#define DL_PF(...) do {} while(0)
#else
#if _MSC_VER >= 1300
#define DL_PF __noop
#else
// avoid warning C4390: ';' : empty controlled statement found; is this the intent?
#define DL_PF(x) do {} while(0)
#pragma warning(disable : 4002) 
#endif
#endif
// END MODIFIED BY Lkb - 9/jun/2001 - GCC support
#endif




#endif // __DAEDALUS_DEBUGDISPLAYLIST_H__
