#ifndef FFXMATHS_H__
#define FFXMATHS_H__

static float InvSqrt(float x)
{
	float xhalf = 0.5f*x;
	int i = *(int*)&x;			// get bits for floating value
	i = 0x5f3759df - (i>>1);	// gives initial guess y0
	x = *(float*)&i;			// convert bits back to float
	x = x*(1.5f-xhalf*x*x);		// Newton step, repeating increases accuracy
	//x = x*(1.5f-xhalf*x*x);		// Newton step, repeating increases accuracy
	//x = x*(1.5f-xhalf*x*x);		// Newton step, repeating increases accuracy
	//x = x*(1.5f-xhalf*x*x);		// Newton step, repeating increases accuracy
	//x = x*(1.5f-xhalf*x*x);		// Newton step, repeating increases accuracy

	return x;
}

static inline float Sqrt( float x )
{
	return x * InvSqrt( x );
}

static inline float frand()
{
	int x = (rand()*rand()) & 0x007fffff;
	x |= 0x3f800000;				// 1.0f in IEEE fp
	return (*(float*)&x) - 1.0f;
}

// Returns in rand -1 .. +1
static inline float frand_11()
{
	return (frand() * 2.0f) - 1.0f;
}

static inline float frand_range( float lo, float hi )
{
	return lo + (hi - lo) * frand();
}

template< typename T > T Square( T x )
{
	return x * x;
}

template< typename T > T Clamp( T x, T lo, T hi )
{
	if(x < lo)
		return lo;
	else if(x > hi)
		return hi;
	else
		return x;
}

#endif // FFXMATHS_H__
