#ifndef VECTOR4_H__
#define VECTOR4_H__


class v4
{
public:
	v4() {}
	v4( float _x, float _y, float _z, float _w ) : x( _x ), y( _y ), z( _z ), w( _w ) {}

	float Normalise()
	{
		float	len( Length() );
		if(len > 0.0001f)
		{
			float r( 1.0f / len );
			x *= r;
			y *= r;
			z *= r;
			w *= r;
		}

		return len;
	}

	float Length() const
	{
		return 1.0f / InvSqrt( (x*x)+(y*y)+(z*z)+(w*w) );
	}


	float x, y, z, w;
};

class c4
{
public:
	c4()
		:	a( 1.0f )
		,	r( 1.0f )
		,	g( 1.0f )
		,	b( 1.0f )
	{
	}

	float	a, r, g, b;
};


#endif // VECTOR4_H__
